unit Umain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls;

type
  Tmainform = class(TForm)
    cmd_Write: TButton;
    cmd_Stop: TButton;
    Image1: TImage;
    cmd_Exit: TButton;
    FontDialog1: TFontDialog;
    cmd_Font: TButton;
    ColorDialog1: TColorDialog;
    cmd_Colour: TButton;
    cmd_Clear: TButton;
    edit_Speed: TEdit;
    UpDown1: TUpDown;
    Label1: TLabel;
    chk_EOLPause: TCheckBox;
    cmb_SoundNumber: TComboBox;
    cmd_About: TButton;
    img_ProgIcon: TImage;
    Label2: TLabel;
    img_Stop: TImage;
    Memo1: TMemo;
    Label3: TLabel;
    cmd_ClearText: TButton;
    Label4: TLabel;
    procedure cmd_WriteClick(Sender: TObject);
    procedure cmd_StopClick(Sender: TObject);
    procedure cmd_ExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmd_FontClick(Sender: TObject);
    procedure cmd_ColourClick(Sender: TObject);
    procedure cmd_ClearClick(Sender: TObject);
    procedure edit_SpeedChange(Sender: TObject);
    procedure chk_EOLPauseClick(Sender: TObject);
    procedure cmb_SoundNumberChange(Sender: TObject);
    procedure cmd_AboutClick(Sender: TObject);
    procedure cmd_ClearTextClick(Sender: TObject);
  private
    { Private declarations }
    aFontSize:Integer;
    aColour:LongInt;
    aFontName:String;
    aSpeed:Integer;
    aEOLPause:Boolean;
    aSoundNumber:Word;
    Function GetLineNumberFromCursor:Integer;
  public
    { Public declarations }
  end;

var
  mainform: Tmainform;
  TextString:String;
  aStoredFont:TFONT;

implementation
Uses imptextout32;
{$R *.DFM}
Function Tmainform.GetLineNumberFromCursor:Integer;
begin
Result:=Integer(SendMessage(Memo1.Handle,EM_LINEFROMCHAR,memo1.Selstart,0));
end;

procedure Tmainform.cmd_WriteClick(Sender: TObject);
Var
 s:String;
 f:Integer;
begin
Image1.Repaint;
cmd_Write.Font.Style:=[];
cmd_Stop.Font.Style:=[fsBold];
for f:=0 to Memo1.Lines.Count-1 do
 s:=s + memo1.lines[f];
WriteText(Handle,10,10,300,aFontSize,aColour,PChar(aFontName),
PChar(s),aSpeed,aEOLPause,aSoundNumber,6,236,32,32);
cmd_Write.Font.Style:=[fsBold];
cmd_Stop.Font.Style:=[];

end;


procedure Tmainform.cmd_StopClick(Sender: TObject);
begin
StopWriting;
cmd_Write.Font.Style:=[fsBold];
cmd_Stop.Font.Style:=[];
end;

procedure Tmainform.cmd_ExitClick(Sender: TObject);
begin
Close;
end;

procedure Tmainform.FormCreate(Sender: TObject);
begin
aColour:=0;
aStoredFont:=Font;
aFontName:=Font.Name;
aFontSize:=Font.Size;
aSpeed:=100;
aEOLPause:=TRUE;
aSoundNumber:=0;
cmb_SoundNumber.ItemIndex:=0;
Icon:=Application.Icon;
img_ProgIcon.Picture.Icon:=Application.Icon;
TextString:='Rimmer tried to smile charmingly, which was always a mistake for him.';
TextString:=TextString + ' He had a vulture' + #146 + 's smile, perhaps because he practised it';
TextString:= TextString + ' so little, and it always provoked the opposite reaction from';
TextString:= TextString + ' the one he intended.';
Memo1.Lines.Add(TextString);
end;

procedure Tmainform.cmd_FontClick(Sender: TObject);
begin
FontDialog1.Font.Size:=aFontSize;
if Pos('+',aFontName) > 0 then aFontName:=Copy(aFontName,1,Pos('+',aFontName)-1);
FontDialog1.Font.Name:=aFontName;
FontDialog1.Font:=aStoredFont;
if FontDialog1.Execute then
 begin
   aFontSize:=FontDialog1.Font.Size;
   aFontName:=FontDialog1.Font.Name;
   aStoredFont:=FontDialog1.Font;
   If fsBold in FontDialog1.Font.Style then aFontName:=aFontName + '+Bold';
   If fsItalic in FontDialog1.Font.Style then aFontName:=aFontName + '+Italic';
   If fsUnderline in FontDialog1.Font.Style then aFontName:=aFontName + '+Underline';
   If fsStrikeout in FontDialog1.Font.Style then aFontName:=aFontName + '+strikeout';
 end;
end;

procedure Tmainform.cmd_ColourClick(Sender: TObject);
begin
if ColorDialog1.Execute then
 begin
  aColour:=LongInt(ColorDialog1.Color);
 end;
end;

procedure Tmainform.cmd_ClearClick(Sender: TObject);
begin
Image1.Repaint;
end;

procedure Tmainform.edit_SpeedChange(Sender: TObject);
begin
aSpeed:=StrToInt(edit_Speed.Text);
end;

procedure Tmainform.chk_EOLPauseClick(Sender: TObject);
begin
aEOLPause:=chk_EOLPause.Checked;
end;

procedure Tmainform.cmb_SoundNumberChange(Sender: TObject);
begin
aSoundNumber:=cmb_SoundNumber.ItemIndex;


end;

procedure Tmainform.cmd_AboutClick(Sender: TObject);
begin
DLLAbout;
end;


procedure Tmainform.cmd_ClearTextClick(Sender: TObject);
begin
Memo1.Clear;
end;

end.
